Package: nfer
Title: Event Stream Abstraction using Interval Logic
Version: 1.1.3
Authors@R: 
    person("Sean", "Kauffman", , "seank@cs.aau.dk", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-6341-3898"))
Description: This is the R API for the 'nfer' formalism (<http://nfer.io/>).
    'nfer' was developed to specify event stream abstractions for spacecraft 
    telemetry such as the Mars Science Laboratory.  Users write rules using 
    a syntax that borrows heavily from Allen's Temporal Logic that, when 
    applied to an event stream, construct a hierarchy of temporal intervals 
    with data.  The R API supports loading rules from a file or mining them 
    from historical data.  Traces of events or pools of intervals are 
    provided as data frames.
License: GPL (>= 3)
Encoding: UTF-8
URL: http://nfer.io/
BugReports: https://bitbucket.org/seanmk/nfer/issues
RoxygenNote: 7.2.3
Suggests: knitr, rmarkdown, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
NeedsCompilation: yes
Packaged: 2023-04-12 09:43:11 UTC; sb37fk
Author: Sean Kauffman [aut, cre] (<https://orcid.org/0000-0001-6341-3898>)
Maintainer: Sean Kauffman <seank@cs.aau.dk>
Repository: CRAN
Date/Publication: 2023-04-12 10:00:02 UTC
Built: R 4.4.0; x86_64-apple-darwin17.7.0; 2024-04-30 00:02:17 UTC; unix

Package: nfer
Title: Event Stream Abstraction using Interval Logic
Version: 1.1.3
Authors@R: 
    person("Sean", "Kauffman", , "seank@cs.aau.dk", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-6341-3898"))
Description: This is the R API for the 'nfer' formalism (<http://nfer.io/>).
    'nfer' was developed to specify event stream abstractions for spacecraft 
    telemetry such as the Mars Science Laboratory.  Users write rules using 
    a syntax that borrows heavily from Allen's Temporal Logic that, when 
    applied to an event stream, construct a hierarchy of temporal intervals 
    with data.  The R API supports loading rules from a file or mining them 
    from historical data.  Traces of events or pools of intervals are 
    provided as data frames.
License: GPL (>= 3)
Encoding: UTF-8
URL: http://nfer.io/
BugReports: https://bitbucket.org/seanmk/nfer/issues
RoxygenNote: 7.2.3
Suggests: knitr, rmarkdown, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
NeedsCompilation: yes
Packaged: 2023-04-12 09:43:11 UTC; sb37fk
Author: Sean Kauffman [aut, cre] (<https://orcid.org/0000-0001-6341-3898>)
Maintainer: Sean Kauffman <seank@cs.aau.dk>
Repository: CRAN
Date/Publication: 2023-04-12 10:00:02 UTC
Built: R 4.4.0; x86_64-apple-darwin18.7.0; 2024-05-06 22:16:04 UTC; unix

test_that("filename is type checked", {
  expect_error(nfer::load(3), "== \"character\"")
  expect_error(nfer::load(TRUE), "== \"character\"")
  expect_error(nfer::load(as.factor("x")), "== \"character\"")
})

test_that("log level is type checked", {
  expect_error(nfer::load(system.file("extdata", "ops.nfer", package = "nfer"), "3"), "== \"numeric\"")
  expect_error(nfer::load(system.file("extdata", "ops.nfer", package = "nfer"), TRUE), "== \"numeric\"")
  expect_error(nfer::load(system.file("extdata", "ops.nfer", package = "nfer"), as.factor("3")), "== \"numeric\"")
})

test_that("non-extant spec files throw an error", {
  expect_error(nfer::load("foo"), "Unable to load specification")
})

test_that("log level is set", {
  skip("there doesn't seem to be a way to check REprintf output")
  spec   <- nfer::load(system.file("extdata", "ops.nfer", package = "nfer"), 1)
  input  <- nfer::read(system.file("extdata", "ops.events", package = "nfer"))
  expect_output(nfer::apply(spec, input), "Creating initial pool")
})

test_that("nfer correctly handles cycle-three", {
  # skip as we have to set --full and this isn't supported yet from R
  skip("--full option not yet supported in R")
  spec   <- nfer::load(system.file("extdata", "cycle_three.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "cycle_three.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "A")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "3")
  row <- result[2,]
  expect_equal(row$name, "A")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "2")
  row <- result[3,]
  expect_equal(row$name, "A")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "1")
  row <- result[4,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "3")
  row <- result[5,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "2")
  row <- result[6,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "1")
  row <- result[7,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "3")
  row <- result[8,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "2")
  row <- result[9,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "1")
})

test_that("nfer correctly handles simple_coincide", {
  spec   <- nfer::load(system.file("extdata", "simple_coincide.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_coincide.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  row <- result[3,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 40)
  expect_equal(row$end, 50)
  row <- result[4,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 40)
  expect_equal(row$end, 50)
  row <- result[5,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 40)
  expect_equal(row$end, 50)
})

test_that("nfer correctly handles where_after_lhs", {
  spec   <- nfer::load(system.file("extdata", "where_after_lhs.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_after_lhs.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 20)
  expect_equal(row$end, 20)
})

test_that("nfer correctly handles simple_contain", {
  spec   <- nfer::load(system.file("extdata", "simple_contain.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_contain.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  row <- result[3,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 40)
  row <- result[4,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 60)
  expect_equal(row$end, 70)
  row <- result[5,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 50)
  expect_equal(row$end, 80)
})

test_that("nfer correctly handles nested_time", {
  spec   <- nfer::load(system.file("extdata", "nested_time.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_time.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "BOOT")
  expect_equal(row$start, 42)
  expect_equal(row$end, 160)
  expect_equal(row$count, "3")
  row <- result[2,]
  expect_equal(row$name, "RISK")
  expect_equal(row$start, 160)
  expect_equal(row$end, 255)
  row <- result[3,]
  expect_equal(row$name, "BOOT")
  expect_equal(row$start, 255)
  expect_equal(row$end, 312)
  expect_equal(row$count, "4")
})

# fixed by hand because the order changes from online monitoring
test_that("nfer correctly handles simple_finish", {
  spec   <- nfer::load(system.file("extdata", "simple_finish.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_finish.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[3,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  row <- result[1,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[6,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 50)
  expect_equal(row$end, 60)
  row <- result[4,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 40)
  expect_equal(row$end, 60)
  row <- result[5,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 40)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles nested_contain_map", {
  spec   <- nfer::load(system.file("extdata", "nested_contain_map.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_contain_map.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 20)
  expect_equal(row$end, 50)
})

test_that("nfer correctly handles where_atomic", {
  spec   <- nfer::load(system.file("extdata", "where_atomic.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_atomic.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 10)
  expect_equal(row$end, 10)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 50)
  expect_equal(row$end, 50)
})

test_that("nfer correctly handles where_after_both_eq", {
  spec   <- nfer::load(system.file("extdata", "where_after_both_eq.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_after_both_eq.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 40)
  expect_equal(row$end, 40)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 60)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles nested_map_or", {
  spec   <- nfer::load(system.file("extdata", "nested_map_or.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_map_or.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 20)
  expect_equal(row$end, 50)
  row <- result[2,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 100)
  expect_equal(row$end, 130)
})

test_that("nfer correctly handles exponential", {
  # skip exponential as we have to set --full and this isn't supported yet from R
  skip("--full option not yet supported in R")
  spec   <- nfer::load(system.file("extdata", "exponential.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "exponential.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "0")
  row <- result[2,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "3")
  row <- result[3,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "1")
  row <- result[4,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  expect_equal(row$v, "2")
})

test_that("nfer correctly handles nested_after_where", {
  spec   <- nfer::load(system.file("extdata", "nested_after_where.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_after_where.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 20)
  expect_equal(row$end, 50)
  row <- result[2,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 40)
  expect_equal(row$end, 70)
})

test_that("nfer correctly handles docs_also", {
  spec   <- nfer::load(system.file("extdata", "docs_also.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_also.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
})

test_that("nfer correctly handles docs_comment", {
  spec   <- nfer::load(system.file("extdata", "docs_comment.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_comment.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  expect_equal(row$proc, "1")
  expect_equal(row$comment, "running")
  row <- result[2,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
  expect_equal(row$proc, "2")
  expect_equal(row$comment, "running")
})

test_that("nfer correctly handles simple_after", {
  spec   <- nfer::load(system.file("extdata", "simple_after.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_after.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 20)
  expect_equal(row$end, 20)
})

test_that("nfer correctly handles simple_meet", {
  spec   <- nfer::load(system.file("extdata", "simple_meet.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_meet.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 40)
  row <- result[3,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 40)
  expect_equal(row$end, 50)
  row <- result[4,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 40)
  expect_equal(row$end, 70)
  row <- result[5,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 50)
  expect_equal(row$end, 70)
  row <- result[6,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 60)
  expect_equal(row$end, 70)
})

test_that("nfer correctly handles simple_utf8", {
  l10n <- l10n_info()
  if (l10n$`UTF-8`) {
    spec   <- nfer::load(system.file("extdata", "simple_utf8.nfer", package = "nfer"))
    input  <- nfer::read(system.file("extdata", "simple_utf8.events", package = "nfer"))
    result <- nfer::apply(spec, input)
    row <- result[1,]
    expect_equal(row$name, "身体")
    expect_equal(row$start, 30)
    expect_equal(row$end, 40)
    row <- result[2,]
    expect_equal(row$name, "身体")
    expect_equal(row$start, 50)
    expect_equal(row$end, 60)
  } else {
    skip("No UTF-8 support in this R build!")
  }
})

test_that("nfer correctly handles where_after_both", {
  spec   <- nfer::load(system.file("extdata", "where_after_both.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_after_both.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 30)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 40)
  expect_equal(row$end, 40)
  row <- result[3,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 60)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles where_after_map", {
  spec   <- nfer::load(system.file("extdata", "where_after_map.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_after_map.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 20)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 60)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles fmsd_risk_nested", {
  spec   <- nfer::load(system.file("extdata", "fmsd_risk_nested.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "fmsd_risk_nested.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "BOOT")
  expect_equal(row$start, 42)
  expect_equal(row$end, 160)
  expect_equal(row$count, "3")
  row <- result[2,]
  expect_equal(row$name, "RISK")
  expect_equal(row$start, 42)
  expect_equal(row$end, 312)
  expect_equal(row$count, "3")
  row <- result[3,]
  expect_equal(row$name, "BOOT")
  expect_equal(row$start, 255)
  expect_equal(row$end, 312)
  expect_equal(row$count, "4")
})

test_that("nfer correctly handles where_after", {
  spec   <- nfer::load(system.file("extdata", "where_after.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_after.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 20)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 40)
  expect_equal(row$end, 40)
})

test_that("nfer correctly handles nested_map", {
  spec   <- nfer::load(system.file("extdata", "nested_map.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_map.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 50)
  expect_equal(row$end, 80)
})

test_that("nfer correctly handles docs_import", {
  spec   <- nfer::load(system.file("extdata", "docs_import.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_import.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "TESTING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "TWOTESTS")
  expect_equal(row$start, 10)
  expect_equal(row$end, 65)
  row <- result[3,]
  expect_equal(row$name, "TESTING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
})

test_that("nfer correctly handles simple_start", {
  spec   <- nfer::load(system.file("extdata", "simple_start.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_start.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[3,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[4,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 40)
  expect_equal(row$end, 50)
  row <- result[5,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 40)
  expect_equal(row$end, 60)
  row <- result[6,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 40)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles docs_testing", {
  spec   <- nfer::load(system.file("extdata", "docs_testing.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_testing.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  expect_equal(row$proc, "1")
  row <- result[2,]
  expect_equal(row$name, "TESTING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[3,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
  expect_equal(row$proc, "2")
  row <- result[4,]
  expect_equal(row$name, "TESTING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
})

test_that("nfer correctly handles simple_overlap", {
  spec   <- nfer::load(system.file("extdata", "simple_overlap.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_overlap.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  row <- result[3,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 30)
  expect_equal(row$end, 50)
  row <- result[4,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 30)
  expect_equal(row$end, 60)
  row <- result[5,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 40)
  expect_equal(row$end, 60)
  row <- result[6,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 40)
  expect_equal(row$end, 70)
  row <- result[7,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 50)
  expect_equal(row$end, 70)
})

test_that("nfer correctly handles docs_nested_testing", {
  spec   <- nfer::load(system.file("extdata", "docs_nested_testing.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_nested_testing.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "TESTING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "TESTING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
})

test_that("nfer correctly handles simple_follow", {
  spec   <- nfer::load(system.file("extdata", "simple_follow.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_follow.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 40)
  row <- result[3,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 20)
  expect_equal(row$end, 40)
  row <- result[4,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 40)
  expect_equal(row$end, 50)
  row <- result[5,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 50)
  expect_equal(row$end, 70)
  row <- result[6,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 60)
  expect_equal(row$end, 70)
})

test_that("nfer correctly handles simple_during", {
  spec   <- nfer::load(system.file("extdata", "simple_during.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_during.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 40)
  row <- result[3,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 60)
  expect_equal(row$end, 70)
  row <- result[4,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 50)
  expect_equal(row$end, 80)
  row <- result[5,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 50)
  expect_equal(row$end, 80)
})

test_that("nfer correctly handles where_real_equals", {
  spec   <- nfer::load(system.file("extdata", "where_real_equals.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_real_equals.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 10)
  expect_equal(row$end, 40)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 30)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles nested_bool", {
  spec   <- nfer::load(system.file("extdata", "nested_bool.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_bool.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 70)
  expect_equal(row$end, 90)
})

test_that("nfer correctly handles where_bool", {
  spec   <- nfer::load(system.file("extdata", "where_bool.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_bool.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 50)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles nested_coincide", {
  spec   <- nfer::load(system.file("extdata", "nested_coincide.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_coincide.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 40)
  expect_equal(row$end, 50)
})

test_that("nfer correctly handles docs_atomic", {
  spec   <- nfer::load(system.file("extdata", "docs_atomic.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_atomic.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "STARTING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 10)
  expect_equal(row$pid, "1")
  row <- result[2,]
  expect_equal(row$name, "SUCCESS")
  expect_equal(row$start, 15)
  expect_equal(row$end, 15)
  row <- result[3,]
  expect_equal(row$name, "ENDING")
  expect_equal(row$start, 20)
  expect_equal(row$end, 20)
  expect_equal(row$pid, "1")
  row <- result[4,]
  expect_equal(row$name, "STARTING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 50)
  expect_equal(row$pid, "2")
  row <- result[5,]
  expect_equal(row$name, "ENDING")
  expect_equal(row$start, 65)
  expect_equal(row$end, 65)
  expect_equal(row$pid, "2")
})

test_that("nfer correctly handles fmsd_risk", {
  spec   <- nfer::load(system.file("extdata", "fmsd_risk.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "fmsd_risk.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "BOOT")
  expect_equal(row$start, 42)
  expect_equal(row$end, 160)
  expect_equal(row$count, "3")
  row <- result[2,]
  expect_equal(row$name, "DBOOT")
  expect_equal(row$start, 42)
  expect_equal(row$end, 312)
  expect_equal(row$count, "3")
  row <- result[3,]
  expect_equal(row$name, "RISK")
  expect_equal(row$start, 42)
  expect_equal(row$end, 312)
  expect_equal(row$count, "3")
  row <- result[4,]
  expect_equal(row$name, "BOOT")
  expect_equal(row$start, 255)
  expect_equal(row$end, 312)
  expect_equal(row$count, "4")
})

test_that("nfer correctly handles where_bool_equals", {
  spec   <- nfer::load(system.file("extdata", "where_bool_equals.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_bool_equals.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 10)
  expect_equal(row$end, 40)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 30)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles nested_during", {
  spec   <- nfer::load(system.file("extdata", "nested_during.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_during.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 50)
  expect_equal(row$end, 80)
})

test_that("nfer correctly handles simple_slice", {
  spec   <- nfer::load(system.file("extdata", "simple_slice.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_slice.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  row <- result[3,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 30)
  expect_equal(row$end, 50)
  row <- result[4,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 40)
  expect_equal(row$end, 50)
  row <- result[5,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 40)
  expect_equal(row$end, 60)
  row <- result[6,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 50)
  expect_equal(row$end, 60)
  row <- result[7,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 50)
  expect_equal(row$end, 70)
})

test_that("nfer correctly handles where_string_equals", {
  spec   <- nfer::load(system.file("extdata", "where_string_equals.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_string_equals.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 10)
  expect_equal(row$end, 40)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 30)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles docs_operating", {
  spec   <- nfer::load(system.file("extdata", "docs_operating.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_operating.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
})

test_that("nfer correctly handles simple_before", {
  spec   <- nfer::load(system.file("extdata", "simple_before.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "simple_before.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 30)
  expect_equal(row$end, 40)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 50)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles docs_two_close_ops", {
  spec   <- nfer::load(system.file("extdata", "docs_two_close_ops.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_two_close_ops.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "TWO_CLOSE_OPS")
  expect_equal(row$start, 10)
  expect_equal(row$end, 65)
  row <- result[3,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
})

test_that("nfer correctly handles docs_short_op", {
  spec   <- nfer::load(system.file("extdata", "docs_short_op.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_short_op.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "SHORT_OP")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
})

test_that("nfer correctly handles docs_pid_equals", {
  spec   <- nfer::load(system.file("extdata", "docs_pid_equals.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_pid_equals.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
})

test_that("nfer correctly handles where_int_equals", {
  spec   <- nfer::load(system.file("extdata", "where_int_equals.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "where_int_equals.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 10)
  expect_equal(row$end, 40)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 30)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles docs_failure", {
  spec   <- nfer::load(system.file("extdata", "docs_failure.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "docs_failure.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "SUCCESS")
  expect_equal(row$start, 15)
  expect_equal(row$end, 15)
  row <- result[2,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 10)
  expect_equal(row$end, 20)
  row <- result[3,]
  expect_equal(row$name, "OPERATING")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
  row <- result[4,]
  expect_equal(row$name, "FAILURE")
  expect_equal(row$start, 50)
  expect_equal(row$end, 65)
})

test_that("nfer correctly handles nested_bool_equals", {
  spec   <- nfer::load(system.file("extdata", "nested_bool_equals.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_bool_equals.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 40)
  expect_equal(row$end, 90)
})

test_that("nfer correctly handles dupl_equals", {
  spec   <- nfer::load(system.file("extdata", "dupl_equals.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "dupl_equals.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "A")
  expect_equal(row$start, 10)
  expect_equal(row$end, 50)
  row <- result[2,]
  expect_equal(row$name, "A")
  expect_equal(row$start, 20)
  expect_equal(row$end, 60)
})

test_that("nfer correctly handles dupl_simple", {
  spec   <- nfer::load(system.file("extdata", "dupl_simple.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "dupl_simple.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "A")
  expect_equal(row$start, 20)
  expect_equal(row$end, 40)
  row <- result[2,]
  expect_equal(row$name, "A")
  expect_equal(row$start, 40)
  expect_equal(row$end, 60)
})

test_that("argument numbers are checked", {
  input <- data.frame(c(1,2,3))
  expect_error(nfer::learn(input), "length")
})

test_that("event name type is checked", {
  input <- data.frame(c(2),c(1))
  expect_error(nfer::learn(input), "== \"character\"")
})

test_that("timestamp is type checked", {
  input <- data.frame(c("x"),c(TRUE))
  expect_error(nfer::learn(input), "== \"integer\"")
})

test_that("log level is type checked", {
  input <- data.frame(c("x"),c(1))
  expect_error(nfer::learn(input, "3"), "== \"numeric\"")
  expect_error(nfer::learn(input, TRUE), "== \"numeric\"")
  expect_error(nfer::learn(input, as.factor("3")), "== \"numeric\"")
})

test_that("nfer correctly handles exclusive_order", {
  spec   <- nfer::load(system.file("extdata", "exclusive_order.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "exclusive_order.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 0)
  expect_equal(row$end, 0)
  row <- result[2,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 1)
  expect_equal(row$end, 1)
})

test_that("nfer correctly handles nested_ends", {
  spec   <- nfer::load(system.file("extdata", "nested_ends.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "nested_ends.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 20)
  expect_equal(row$end, 20)
  row <- result[2,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[3,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 10)
  expect_equal(row$end, 30)
  row <- result[4,]
  expect_equal(row$name, "F")
  expect_equal(row$start, 80)
  expect_equal(row$end, 80)
  row <- result[5,]
  expect_equal(row$name, "E")
  expect_equal(row$start, 70)
  expect_equal(row$end, 90)
  row <- result[6,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 70)
  expect_equal(row$end, 90)
})

test_that("nfer correctly handles constant", {
  spec   <- nfer::load(system.file("extdata", "constant.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "constant.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 60)
  expect_equal(row$end, 70)
})

test_that("nfer correctly handles constant_ends", {
  spec   <- nfer::load(system.file("extdata", "constant_ends.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "constant_ends.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 21)
  expect_equal(row$end, 32)
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 61)
  expect_equal(row$end, 72)
})

test_that("nfer correctly handles constant_map", {
  spec   <- nfer::load(system.file("extdata", "constant_map.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "constant_map.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 20)
  expect_equal(row$end, 30)
  expect_equal(row$y, "3")
  row <- result[2,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 60)
  expect_equal(row$end, 70)
  expect_equal(row$y, "3")
})

test_that("handle size is checked", {
  handle <- list(as.integer(1))
  input <- data.frame(c("x"),c(1))
  expect_error(nfer::apply(handle, input), "length")
})

test_that("log level type is checked", {
  handle <- list(1,2)
  input <- data.frame(c("x"),c(1))
  expect_error(nfer::apply(handle, input), "== \"integer\"")
})

test_that("event name type is checked", {
  handle <- list(as.integer(1),2)
  input <- data.frame(c(2),c(1))
  expect_error(nfer::apply(handle, input), "== \"character\"")
})

test_that("timestamp is type checked", {
  handle <- list(as.integer(1),2)
  input <- data.frame(c("x"),c(TRUE))
  expect_error(nfer::apply(handle, input), "== \"integer\"")
})

test_that("nfer correctly handles exclude_self", {
  spec   <- nfer::load(system.file("extdata", "exclude_self.nfer", package = "nfer"))
  input  <- nfer::read(system.file("extdata", "exclude_self.events", package = "nfer"))
  result <- nfer::apply(spec, input)
  row <- result[1,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 1)
  expect_equal(row$x, "0")
  row <- result[2,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 0)
  expect_equal(row$end, 1)
  expect_equal(row$x, "1")
  row <- result[3,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 0)
  expect_equal(row$end, 1)
  row <- result[4,]
  expect_equal(row$name, "D")
  expect_equal(row$start, 0)
  expect_equal(row$end, 2)
  row <- result[6,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 1)
  expect_equal(row$end, 2)
  expect_equal(row$x, "0")
  row <- result[7,]
  expect_equal(row$name, "B")
  expect_equal(row$start, 1)
  expect_equal(row$end, 2)
  expect_equal(row$x, "1")
  row <- result[8,]
  expect_equal(row$name, "C")
  expect_equal(row$start, 1)
  expect_equal(row$end, 2)
  row <- result[5,]
  expect_equal(row$name, "G")
  expect_equal(row$start, 0)
  expect_equal(row$end, 2)
})

test_that("name and timestamp columns have correct names", {
  input <- nfer::read(system.file("extdata", "simple_before.events", package = "nfer"))
  expect_equal(names(input)[1], "Name")
  expect_equal(names(input)[2], "Time")
})

test_that("boolean data columns are set correctly", {
  input <- nfer::read(system.file("extdata", "where_bool.events", package = "nfer"))
  expect_equal(names(input)[3], "foo")
  expect_equal(class(input$foo), "logical")
  expect_equal(input[1,]$foo, TRUE)
  expect_equal(input[2,]$foo, NA)
  expect_equal(input[3,]$foo, FALSE)
  expect_equal(input[4,]$foo, NA)
  expect_equal(input[5,]$foo, TRUE)
  expect_equal(input[6,]$foo, NA)
})

test_that("int data columns are set correctly", {
  input <- nfer::read(system.file("extdata", "where_int_equals.events", package = "nfer"))
  expect_equal(names(input)[3], "foo")
  expect_equal(names(input)[4], "bar")
  expect_equal(class(input$foo), "integer")
  expect_equal(class(input$bar), "integer")
  expect_equal(input[1,]$foo, 1)
  expect_equal(input[2,]$foo, NA_integer_)
  expect_equal(input[3,]$foo, 3)
  expect_equal(input[4,]$foo, NA_integer_)
  expect_equal(input[5,]$foo, 2)
  expect_equal(input[6,]$foo, NA_integer_)
  expect_equal(input[1,]$bar, NA_integer_)
  expect_equal(input[2,]$bar, 2)
  expect_equal(input[3,]$bar, NA_integer_)
  expect_equal(input[4,]$bar, 1)
  expect_equal(input[5,]$bar, NA_integer_)
  expect_equal(input[6,]$bar, 3)
})

test_that("real data columns are set correctly", {
  input <- nfer::read(system.file("extdata", "where_real_equals.events", package = "nfer"))
  expect_equal(names(input)[3], "foo")
  expect_equal(names(input)[4], "bar")
  expect_equal(class(input$foo), "numeric")
  expect_equal(class(input$bar), "numeric")
  expect_equal(input[1,]$foo, 1.1)
  expect_equal(input[2,]$foo, NA_real_)
  expect_equal(input[3,]$foo, 3.3)
  expect_equal(input[4,]$foo, NA_real_)
  expect_equal(input[5,]$foo, 2.2)
  expect_equal(input[6,]$foo, NA_real_)
  expect_equal(input[1,]$bar, NA_real_)
  expect_equal(input[2,]$bar, 2.2)
  expect_equal(input[3,]$bar, NA_real_)
  expect_equal(input[4,]$bar, 1.1)
  expect_equal(input[5,]$bar, NA_real_)
  expect_equal(input[6,]$bar, 3.3)
})

test_that("string data columns are set correctly", {
  input <- nfer::read(system.file("extdata", "where_string_equals.events", package = "nfer"))
  expect_equal(names(input)[3], "foo")
  expect_equal(names(input)[4], "bar")
  expect_equal(class(input$foo), "character")
  expect_equal(class(input$bar), "character")
  expect_equal(input[1,]$foo, "one")
  # this is something we have to live with, I think: strings are converted to empty not NA
  expect_equal(input[2,]$foo, "")
  expect_equal(input[3,]$foo, "three")
  expect_equal(input[4,]$foo, "")
  expect_equal(input[5,]$foo, "two")
  expect_equal(input[6,]$foo, "")
  expect_equal(input[1,]$bar, "")
  expect_equal(input[2,]$bar, "two")
  expect_equal(input[3,]$bar, "")
  expect_equal(input[4,]$bar, "one")
  expect_equal(input[5,]$bar, "")
  expect_equal(input[6,]$bar, "three")
})

---
title: "Getting started with nfer"
author: "Sean Kauffman"
date: "2021-11-12"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{getting-started}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

To get started with the nfer R interface, one option is to attach the library.  
The recommended way to use nfer, though, is to just specify the nfer namespace
whenever you use an nfer function.  Throughout this vignette, we'll use the 
nfer namespace.

```{r setup}
library(nfer)
```

There are four functions provided by the nfer package:

* `load`
* `learn`
* `apply`
* `read`

To initialize a specification that can be applied to a dataframe of events, use
the `load` function.  This function takes two parameters: the path to an nfer
specification file and the log level (optional).  

```{r}
ssps <- nfer::load(system.file("extdata", "ssps.nfer", package = "nfer"))
```

This specification can then be applied to a dataframe containing events.  There 
should be at least two columns, the first of which is a character type containing 
the event names, and the second of which is either an integer or a character type 
containing the event timestamps.

The reason for representing timestamps as strings is that integers in R are limited 
to 32 bits, so if you need larger numbers (say, if you have millisecond granularity 
Unix timestamps), they must be character type.
Technically numeric type timestamp columns are supported but discouraged, because 
they risk loss of precision during floating-point conversion.
Internally, timestamps are represented by nfer as 64-bit integers.
Currently the R wrappers will automatically convert factor columns to character 
columns.

```{r}
ssps <- nfer::load(system.file("extdata", "ssps.nfer", package = "nfer"))
df <- read.table(system.file("extdata", "ssps.events", package = "nfer"), sep="|", header=FALSE, colClasses = "character")
intervals <- nfer::apply(ssps, df)
summary(intervals) 
```

If the data frame has more than two columns, the 3rd on will be used as data.  
Events will be assigned data values with a name equal to the name of the 
column whenever the value in the cell corresponding to that event and column 
has a value other than NA.  The `read` function will load event files 
formatted for the command-line version of nfer into a dataframe formatted for 
the R version.

```{r}
test <- nfer::load(system.file("extdata", "ops.nfer", package = "nfer"))
ops <- nfer::read(system.file("extdata", "ops.events", package = "nfer"))
str(ops)
intervals <- nfer::apply(test, ops)
summary(intervals)
```

The nfer mining algorithm can also be used from R using the `learn` function.
The function takes a single parameter which is a data frame of events.  
There should be two columns, the first of which is a character type
containing the event names, and the second of which is an integer, string, or 
numeric type containing the event timestamps.  `learn` also has the same 
optional argument as `load` which is the log level.

The specification returned from `learn` can then be applied to a trace using 
`apply` just like if it had been loaded from a specification file.

```{r}
df <- read.table(system.file("extdata", "ssps.events", package = "nfer"), sep="|", header=FALSE)
learned <- nfer::learn(df)
intervals <- nfer::apply(learned, df)
summary(intervals)
```
